require_relative '../lib/build'
require 'semver'
require 'test/unit'

VERSIONING = 'test'

class TestVersioning < Test::Unit::TestCase

  def test_version_multiple_semver_no_build_counter
    versioning 'TEST', 'Test.semver'
    assert_equal ENV['TEST_NUGET_VERSION'] , '1.1.1-develop'
    assert ENV['TEST_BUILD_VERSION'].start_with?('1.1.1-develop'), 'Matched'
    assert_equal ENV['TEST_FORMAL_VERSION'], '1.1.1.0'
  end

  def test_version_multiple_semver_with_build_counter
    ENV['BUILD_COUNTER'] = '500'
    versioning 'TEST', 'Test.semver'
    assert_equal ENV['TEST_NUGET_VERSION'] , '1.1.1-develop'
    assert ENV['TEST_BUILD_VERSION'] .start_with?('1.1.1-develop'), 'Matched'
    assert_equal ENV['TEST_FORMAL_VERSION'], '1.1.1.500'
    ENV['BUILD_COUNTER'] = nil
  end

  def test_version_single_semver_no_build_counter
    versioning
    assert ENV['BUILD_VERSION'].start_with?('2.4.1-develop')
    assert_equal ENV['NUGET_VERSION'], '2.4.1-develop'
    #assert_match ENV['PLATFORM_VERSION'], Time.new.strftime('%y.%-m.%-d')
    assert ENV['PLATFORM_VERSION'].start_with?('15.12.'), 'Matched'
    #assert_match ENV['PLATFORM_BUILD_VERSION'], Time.new.strftime('%y.%-m.%-d')
    assert_equal ENV['FORMAL_VERSION'], '2.4.1.0'
  end

  def test_version_single_semver_with_build_counter
    ENV['BUILD_COUNTER'] = '500'
    versioning
    assert ENV['BUILD_VERSION'].start_with?('2.4.1-develop')
    assert_equal ENV['NUGET_VERSION'], '2.4.1-develop'
    #assert_match ENV['PLATFORM_VERSION'], Time.new.strftime('%y.%-m.%-d')
    assert ENV['PLATFORM_VERSION'].start_with?('15.12.'), 'Matched'
    #assert_match ENV['PLATFORM_BUILD_VERSION'], Time.new.strftime('%y.%-m.%-d')
    assert_equal ENV['FORMAL_VERSION'], '2.4.1.500'
    ENV['BUILD_COUNTER'] = nil
  end

end
